/**
 * Binary Search and Bubble Sort
 *	. constructor
 *	. method in general
 *	. use of static/non-static methods
 *	. binary search
 *	. bubble sort
 */

public class SearchAndSort {

  // a constructor (which doesn't do anything)
  public SearchAndSort() {}
  
  public static void main( String args[] )
  {
    int a[] = { 14, -2, 5, 3, 7, 20, 17, 8, 10, 8, 5 };

    // output
    print( a, "Array a (before sorting):" );

    // sort
    SearchAndSort sas = new SearchAndSort();
    sas.bubbleSort( a );

    // output
    print( a, "Array a (after sorting):" );


    // search
    for( int i=-10 ; i < 25 ; ++i )
    {
      int index = binarySearch( a, i );
      if( index != -1 )
        System.out.println( "found " + i + " at position " + index );
      else
        System.out.println( i + " is not in the array." );
    }
  }

  public static void print( int x[], String message )
  {
    System.out.println( message );
    System.out.print( "\t" );

    for( int i=0 ; i < x.length ; ++i )
      System.out.print( x[i] + " " );
    System.out.println();
  }

  public static void bubbleSort( int a[] )
  {
    int left = 0;
    while( left < a.length-1 )
    {
      int index = left;
      for( int i=left ; i < a.length ; ++i )
        if( a[i] < a[index] ) index = i;

      // swap a[index] and a[left]
      int tmp = a[index];
      a[index] = a[left];
      a[left] = tmp;

      ++left;
    }    
  }

  /**
   * assume a[] is sorted in ascending order
   */
  public static int binarySearch( int a[], int value )
  {
    int index = -1;
    int left = 0, right = a.length-1, mid;

    while( left <= right )
    {
      mid = (left+right)/2;
      if( a[mid] > value ) right = mid-1;
      else if( a[mid] < value ) left = mid+1;
      else
      {
        index = mid;
        break;
      }
    }

    return index;
  }

} // end of class SearchAndSort

